# Generated by Django 2.0.5 on 2022-01-20 12:41

from django.db import migrations


class Migration(migrations.Migration):
    def add_hours_in_doc_template(apps, schema_editor):
        def add_engineering_hours_breakup(existing_data):
            hours_data_to_add = {
                "engineering_hours_breakup": {
                    "phases": [
                        {
                            "name": "Planning and Design",
                            "hours": 0,
                            "override": False,
                            "after_hours": False,
                            "default": True,
                        },
                        {
                            "name": "Configuration",
                            "hours": 0,
                            "override": False,
                            "after_hours": False,
                            "default": True,
                        },
                        {
                            "name": "Cutover or Activation",
                            "hours": 0,
                            "override": False,
                            "after_hours": False,
                            "default": True,
                        },
                        {
                            "name": "Day One Support",
                            "hours": 0,
                            "override": False,
                            "after_hours": False,
                            "default": True,
                        },
                    ],
                    "total_sites": 0,
                    "total_cutovers": 0,
                },
                "engineering_hours_override": False,
                "after_hours_override": False,
                "project_management_hours_override": False,
            }
            try:
                for key, value in existing_data.items():
                    if key == "service_cost":
                        engineering_hours = value.get("engineering_hours", 0)
                for phase in hours_data_to_add.get("engineering_hours_breakup").get("phases"):
                    if phase.get("name") == "Configuration":
                        phase["hours"] = engineering_hours
                existing_data["service_cost"].update(hours_data_to_add)
            except KeyError:
                pass
            return existing_data

        SOWDocument = apps.get_model("document", "SOWDocument")
        SOWTemplate = apps.get_model("document", "SOWTemplate")

        for doc in SOWDocument.objects.all():
            json_config = add_engineering_hours_breakup(doc.json_config)
            doc.json_config = json_config
            doc.save()

        for template in SOWTemplate.objects.all():
            json_config = add_engineering_hours_breakup(template.json_config)
            template.json_config = json_config
            template.save()

    dependencies = [
        ('document', '0066_auto_20220120_0630'),
    ]

    operations = [
        migrations.RunPython(add_hours_in_doc_template)
    ]